/* X_events.h : part of FancyLauncher
 *
 * provides: X events and loop
 *
 * author: Alexandre David
 * e-mail: adavid@docs.uu.se
 * http://www.docs.uu.se/~adavid
 * license: GPL
 */


#ifndef _X_EVENTS
#define _X_EVENTS

#define INFO "FancyLauncher"
#define VERSION "0.1"

#define MWM_HINTS_DECORATIONS         (1L << 1)
typedef struct _mwmhints
{
   unsigned long       flags;
   unsigned long       functions;
   unsigned long       decorations;
   long                inputMode;
   unsigned long       status;
}
MWMHints;

extern XContext xid_context;
extern Atom   wmDeleteWindow;
extern double tooltip_period;

/* X loop
 */
void X_loop();

/* initialize the buttons and show them
 */
void showButtons(int page);

/* same for extended gadgets
 */
void showExtGadgets();

/* execute a command ; if button==NULL only page, exec and wait are valid
 */
void exec_command(char *command,Gadget *button);

/* register a periodic gadget
 */
void registerPeriodicGadget(Gadget *gad);

/* give the time in double format
 */
double get_time();

#endif
