/* font.h
 * part of FancyLauncher
 * initialize font info from
 * a given font name and draw
 * text on ImlibImage
 *
 * license: GPL
 * author: Alexandre David
 * e-mail: adavid@docs.uu.se
 * http://www.docs.uu.se/~adavid
 */

#ifndef FONT_H
#define FONT_H

#define FIRST_CHAR '%'
#define LAST_CHAR 255
#define NB_CHARS (LAST_CHAR-FIRST_CHAR+1)

typedef struct {
  int width,height,size;
  char *name;
  unsigned int *data;
} FontInfo;


/* load a font and converts the pixels
 * in bit information in order to draw
 * the them manually on any ImlibImage
 */
FontInfo* loadFont(char *name,int boldFirst);


void free_fonts();

#endif
