#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <unistd.h>

const char *keys[]={
  "common","width","height","background","transparent","init","blend_focus",
  "tooltip","border","etched","raised","none","sticky","darker","lighter",
  "0","1","true","false","on","off","transient","persistent","below","wait",
  "action","previous_page","next_page","iconpath","bind",
  "blend_icon","blend_background",
  "exit","exec","configure","about","page","tooltips","snap","restore",
  "icon","x","y","x+","y+","x-","y-","button","{","}",
  "tooltip_wait","tooltip_font","tooltip_background","tooltip_border_width",
  "tooltip_border_height","tooltip_icon",
  "tooltip_red_start","tooltip_red_end",
  "tooltip_green_start","tooltip_green_end",
  "tooltip_blue_start","tooltip_blue_end",
  "digital_clock",
  "color_red_start","color_red_end",
  "color_green_start","color_green_end",
  "color_blue_start","color_blue_end",
  "label","font","posx","posy","update","format",
  "resized_width","resized_height",
  "mail_check","coded_passwd","passwd","new_mail_bg","error_mail_bg","mail"
};

#define N sizeof(keys)/sizeof(char*)

char codestr[]="abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ./01234567890";

char randchar() {
  return codestr[rand()%strlen(codestr)];
}

int codeKey(char *key) {
  int code=0,c;
  while((c=tolower(*key++))!='\0')
    code=37*(code+c);
  return code;
}

char *toUpperString(const char *s) {
  char *res=strdup(s);
  char *tmp=res;
  while(*tmp) {
    *tmp=toupper(*tmp);
    tmp++;
  }
  return res;
}

const char *check(const char *s) {
  switch(*s) {
  case '0': return "ZERO";
  case '1': return "ONE";
  case '{': return "L_PAR";
  case '}': return "R_PAR";
  }
  if (!strcmp("X+",s))
    return "XPLUS";
  if (!strcmp("Y+",s))
    return "YPLUS";
  if (!strcmp("Y-",s))
    return "YMINUS";
  if (!strcmp("X-",s))
    return "XMINUS";
  return s;
}

int main(int argc,char **argv) {
  int i,j;
  int codes[N];
  printf("/* Generated codes */\n");
  for(i=0;i<N;i++) {
    char *s=toUpperString(keys[i]);
    printf("#define %s 0x%x\n",check(s),codes[i]=codeKey(keys[i]));
    free(s);
  }
  for(i=0;i<N-1;i++)
    for(j=i+1;j<N;j++)
      if (codes[i]==codes[j])
	fprintf(stderr,"* Collision %d:%d %s:%s *\n",i,j,keys[i],keys[j]);

  srand(getpid());
  printf("#define SALT_0 %d\n#define SALT_1 %d\n#define CRYPT_KEY \"",randchar(),randchar());
  j=8+rand()%64;
  for(i=0;i<j;i++)
    printf("%c",randchar());
  printf("\"\n#define CRYPT_MASK %d\n",rand()%256);
  printf("\n");
  return 0;
}





